import { FlexibleVaultData, LockupVaultData, LockupStakingAccountData } from "../types";
/**
 * Static abstract class definition to parse entities.
 * @category Parsable
 */
export interface ParsableEntity<T> {
    /**
     * Parse account data
     *
     * @param accountData Buffer data for the entity
     * @returns Parsed entity
     */
    parse: (accountData: Buffer | undefined | null) => T | null;
}
export declare class ParsableFlexibleVault {
    private constructor();
    static parse(data: Buffer | undefined | null): FlexibleVaultData | null;
}
export declare class ParsableLockupVault {
    private constructor();
    static parse(data: Buffer | undefined | null): LockupVaultData | null;
}
export declare class ParsableLockupStakingAccount {
    private constructor();
    static parse(data: Buffer | undefined | null): LockupStakingAccountData | null;
}
