import { TransactionInstruction } from "@solana/web3.js";
import { Context } from "./context";
import * as ixs from "./instructions";
export declare class Methods {
    ctx: Context;
    ix: TransactionInstruction | null | undefined;
    constructor(ctx: Context, ix?: TransactionInstruction);
    withdrawFund(params: ixs.WithdrawFundParams): Promise<this>;
    updateLockupVault(params: ixs.UpdateLockupVaultParams): Promise<this>;
    updateFlexibleVault(params: ixs.UpdateFlexibleVaultParams): Promise<this>;
    initUser(params: ixs.InitUserParams): Promise<this>;
    initFlexibleAccount(params: ixs.InitFlexibleAccountParams): Promise<this>;
    stake(params: ixs.StakeParams): Promise<this>;
    withdraw(params: ixs.WithdrawParams): Promise<this>;
    withdrawDelay(params: ixs.WithdrawDelayParams): Promise<this>;
    claim(params: ixs.ClaimParams): Promise<this>;
    lockup(params: ixs.LockupParams): Promise<this>;
    unlock(params: ixs.UnlockParams): Promise<this>;
}
