import { PublicKey } from "@solana/web3.js";
import BN from "bn.js";

export const PROGRAM_ID = new PublicKey(
  "BEFeA6TSsVphnoiNsmKLbHMBLJwi9PeVCxRD1FDpkPGf"
);

export const STAKING_PROGRAM_ID = PROGRAM_ID;
export const SOLCAT_DECIMALS = 6;

export const SCALE_FACTOR = new BN(10).pow(new BN(18));

export const DISCRIMINATOR_SIZE = 8;
export const PUBKEY_SIZE = 32;
export const U8_SIZE = 1;
export const U16_SIZE = 2;
export const U32_SIZE = 4;
export const U64_SIZE = 8;
export const I64_SIZE = 8;

export const LOCKUP_VAULT_LEN = 8 + 1 + 2 * 2 + 8 + 8 * 3; // 45
export const WITHDRAW_POSITION_LEN = 8 + 1 + 4 + 32 + 8 * 2 + 1; // 62
export const LOCKUP_STAKING_ACCOUNT_LEN = 8 + 1 + 4 + 32 * 2 + 2 + 8 * 2 + 1; // 96
