import { PublicKey, TransactionInstruction } from "@solana/web3.js";
import { Program } from "@coral-xyz/anchor";
import { Staking } from "../artifacts/staking";

export type UnlockParams = {
  accounts: {
    user: PublicKey;
  };
  inputs: {
    index: number;
    vaultIndex: number;
  };
};

export async function unlock(
  program: Program<Staking>,
  params: UnlockParams,
): Promise<TransactionInstruction> {
  const { accounts, inputs } = params;

  const ix = await program.methods
    .unlock(
      inputs.index,
      inputs.vaultIndex,
    )
    .accounts({
      ...accounts,
    })
    .instruction();

  return ix;
}
