import { BN, Program } from "@coral-xyz/anchor";
import { TransactionInstruction } from "@solana/web3.js";
import { Staking } from "../artifacts/staking";

export type WithdrawFundParams = {
  inputs: {
    amount: BN;
  };
};

export async function withdrawFund(
  program: Program<Staking>,
  params: WithdrawFundParams,
): Promise<TransactionInstruction> {
  const { inputs } = params;

  const ix = await program.methods
    .withdrawFund(
      inputs.amount,
    )
    .instruction();

  return ix;
}
